﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Jewles
{
     public partial class Starter : Form
     {
          public Starter()
          {
               InitializeComponent();
          }

          private void Play(object sender, EventArgs e)
          {
               TimeSpan t = new TimeSpan();
               if (timeChbx.Checked)
               {
                    string txt = timeTbx.Text;
                    if (txt.Count(itm => itm == ':') != 1)
                    {
                         MessageBox.Show(this, $"Time is in incorrect format! The correct format is (minutes:seconds).", "Invalid time format!", MessageBoxButtons.OK, MessageBoxIcon.Error);
                         return;
                    }
                    string[] spl = txt.Split(':').Where(itm => !string.IsNullOrWhiteSpace(itm)).ToArray();
                    int m = 0;
                    int s = 0;
                    if (!int.TryParse(spl[0], out m) || !int.TryParse(spl[1], out s))
                    {
                         MessageBox.Show(this, $"Time is in incorrect format! The correct format is (minutes:seconds).", "Invalid time format!", MessageBoxButtons.OK, MessageBoxIcon.Error);
                         return;
                    }
                    t = new TimeSpan(0, 0, m, s);
               }
               if (fileFieldRbtn.Checked)
               {
                    if (!File.Exists(fileTbx.Text))
                    {
                         MessageBox.Show(this, $"The field file '{fileTbx.Text}', does not exist!", "File doesn't exist!", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    else
                    {
                         try
                         {
                              Hide();
                              if (timeChbx.Checked)
                                   new GameWindow(new Game(new GameField(fileTbx.Text), t)).ShowDialog();
                              else
                                   new GameWindow(new Game(new GameField(fileTbx.Text))).ShowDialog();
                              Show();
                         }
                         catch (Exception ex)
                         {
                              Show();
                              MessageBox.Show(this, "An error occured while loading the field file ''!:" + Environment.NewLine + ex.Message, "Error!", MessageBoxButtons.OK, MessageBoxIcon.Error);
                         }
                    }
               }
               else
               {
                    Hide();
                    if (timeChbx.Checked)
                         new GameWindow(new Game(new GameField(), t)).ShowDialog();
                    else
                         new GameWindow(new Game(new GameField())).ShowDialog();
                    Show();
               }
          }

          private void SelectFile(object sender, EventArgs e)
          {
               FileDialog fd = new OpenFileDialog();
               fd.CheckPathExists = true;
               fd.CheckFileExists = true;
               fd.ShowDialog();
               fileTbx.Text = fd.FileName;
          }

          private void FileCheckedChanged(object sender, EventArgs e)
          {
               fileTbx.Enabled = fileFieldRbtn.Checked;
               fileBtn.Enabled = fileFieldRbtn.Checked;
          }

          private void TimeCheckedChanged(object sender, EventArgs e)
          {
               timeTbx.Enabled = timeChbx.Enabled;
          }
     }
}
